Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.security.sasl
Interface SaslServer

All Known Implementing Classes:
  AnonymousServer, CramMD5Server, PlainServer, ServerMechanism, SRPServer

public interface SaslServer

Performs SASL authentication as a server.

A server such as an LDAP server gets an instance of this class in order to perform authentication defined by a specific SASL mechanism. Invoking methods on the `SaslServer` instance generates challenges corresponding to the SASL mechanism implemented by the `SaslServer` instance. As the authentication proceeds, the instance encapsulates the state of a SASL server's authentication exchange.

Here's an example of how an LDAP server might use a `SaslServer` instance. It first gets an instance of a `SaslServer` for the SASL mechanism requested by the client:

    SaslServer ss =
          Sasl.createSaslServer(mechanism, "ldap", myFQDN, props, callbackHandler);

It can then proceed to use the server for authentication. For example, suppose the LDAP server received an LDAP BIND request containing the name of the SASL mechanism and an (optional) initial response. It then might use the server as follows:

    while (!ss.isComplete()) {
       try {
          byte[] challenge = ss.evaluateResponse(response);
          if (ss.isComplete()) {
             status = ldap.sendBindResponse(mechanism, challenge, SUCCESS);
          } else {
             status = ldap.sendBindResponse(mechanism, challenge, SASL_BIND_IN_PROGRESS);
             response = ldap.readBindRequest();
          }
       } catch (SaslException x) {
          status = ldap.sendErrorResponse(x);
          break;
       }
    }
    if (ss.isComplete() && (status == SUCCESS)) {
       String qop = (String) sc.getNegotiatedProperty(Sasl.QOP);
       if (qop != null
             && (qop.equalsIgnoreCase("auth-int")
                || qop.equalsIgnoreCase("auth-conf"))) {
          // Use SaslServer.wrap() and SaslServer.unwrap() for future
          // communication with client
          ldap.in = new SecureInputStream(ss, ldap.in);
          ldap.out = new SecureOutputStream(ss, ldap.out);
       }
    }

See Also:
  `Sasl`, `SaslServerFactory`

Method Summary
`void` | `dispose()` Disposes of any system resources or security-sensitive information the `SaslServer` might be using.
`byte[]` | `evaluateResponse(byte[] response)` Evaluates the response data and generates a challenge.
`java.lang.String` | `getAuthorizationID()` Reports the authorization ID in effect for the client of this session This method can only be called if `isComplete()` returns `true`.
`java.lang.String` | `getMechanismName()` Returns the IANA-registered mechanism name of this SASL server (e.g.
`java.lang.Object` | `getNegotiatedProperty(java.lang.String propName)` Retrieves the negotiated property.
`boolean` | `isComplete()` Determines if the authentication exchange has completed.
`byte[]` | `unwrap(byte[] incoming, int offset, int len)` Unwraps a byte array received from the client.
`byte[]` | `wrap(byte[] outgoing, int offset, int len)` Wraps a byte array to be sent to the client.

Method Detail

### getMechanismName

    public java.lang.String getMechanismName()

  Returns the IANA-registered mechanism name of this SASL server (e.g. "CRAM-MD5", "GSSAPI").

  Returns:
    a non-null string representing the IANA-registered mechanism name.

### evaluateResponse

    public byte[] evaluateResponse(byte[] response)
                            throws SaslException

  Evaluates the response data and generates a challenge. If a response is received from the client during the authentication process, this method is called to prepare an appropriate next challenge to submit to the client. The challenge is `null` if the authentication has succeeded and no more challenge data is to be sent to the client. It is non-null if the authentication must be continued by sending a challenge to the client, or if the authentication has succeeded but challenge data needs to be processed by the client. `isComplete()` should be called after each call to `evaluateResponse()`,to determine if any further response is needed from the client.

  Parameters:
    `response` - the non-null (but possibly empty) response sent by the client.
  Returns:
    the possibly `null` challenge to send to the client. It is `null` if the authentication has succeeded and there is no more challenge data to be sent to the client.
  Throws:
    `SaslException` - if an error occurred while processing the response or generating a challenge.

### isComplete

    public boolean isComplete()

  Determines if the authentication exchange has completed. This method is typically called after each invocation of `evaluateResponse(byte[])` to determine whether the authentication has completed successfully or should be continued.

  Returns:
    `true` if the authentication exchange has completed; `false` otherwise.

### getAuthorizationID

    public java.lang.String getAuthorizationID()

  Reports the authorization ID in effect for the client of this session This method can only be called if `isComplete()` returns `true`.

  Returns:
    the authorization ID of the client.
  Throws:
    `java.lang.IllegalStateException` - if this authentication session has not completed.

### unwrap

    public byte[] unwrap(byte[] incoming,
                         int offset,
                         int len)
                  throws SaslException

  Unwraps a byte array received from the client. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns `true`) and only if the authentication exchange has negotiated integrity and/or privacy as the quality of protection; otherwise, an `IllegalStateException` is thrown.

  `incoming` is the contents of the SASL buffer as defined in RFC 2222 without the leading four octet field that represents the length. `offset` and `len` specify the portion of incoming to use.

  Parameters:
    `incoming` - a non-null byte array containing the encoded bytes from the client.
    `offset` - the starting position at `incoming` of the bytes to use.
    `len` - the number of bytes from `incoming` to use.
  Returns:
    a non-null byte array containing the decoded bytes.
  Throws:
    `SaslException` - if `incoming` cannot be successfully unwrapped.
    `java.lang.IllegalStateException` - if the authentication exchange has not completed, or if the negotiated quality of protection has neither integrity nor privacy.

### wrap

    public byte[] wrap(byte[] outgoing,
                       int offset,
                       int len)
                throws SaslException

  Wraps a byte array to be sent to the client. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns `true`) and only if the authentication exchange has negotiated integrity and/or privacy as the quality of protection; otherwise, an `IllegalStateException` is thrown.

  The result of this method will make up the contents of the SASL buffer as defined in RFC 2222 without the leading four octet field that represents the length. `offset` and `len` specify the portion of `outgoing` to use.

  Parameters:
    `outgoing` - a non-null byte array containing the bytes to encode.
    `offset` - the starting position at `outgoing` of the bytes to use.
    `len` - the number of bytes from `outgoing` to use.
  Returns:
    a non-null byte array containing the encoded bytes.
  Throws:
    `SaslException` - if `outgoing` cannot be successfully wrapped.
    `java.lang.IllegalStateException` - if the authentication exchange has not completed, or if the negotiated quality of protection has neither integrity nor privacy.

### getNegotiatedProperty

    public java.lang.Object getNegotiatedProperty(java.lang.String propName)
                                           throws SaslException

  Retrieves the negotiated property. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns `true`); otherwise, an `IllegalStateException` is thrown.

  Returns:
    the value of the negotiated property. If `null`, the property was not negotiated or is not applicable to this mechanism.
  Throws:
    `java.lang.IllegalStateException` - if this authentication exchange has not completed.
    `SaslException`

### dispose

    public void dispose()
                 throws SaslException

  Disposes of any system resources or security-sensitive information the `SaslServer` might be using. Invoking this method invalidates the `SaslServer` instance. This method is idempotent.

  Throws:
    `SaslException` - if a problem was encountered while disposing of the resources.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.